PROGRAM MyType003;

USES
	Types,   QuickDraw, Events, Windows, Dialogs, Fonts, DiskInit, 
	Devices, TextEdit,  Traps,  Memory,  Processes, Scrap, ToolUtils, 
	OSUtils,   Menus, Palettes, GestaltEqu , Lists, TextUtils,
	QuickDrawText, Resources, Controls, Printing, MixedMode, Folders, Finder,
	Files,
	
	Globals, MyPrinting;



{ Utility code *********************************************************** }


{ Adjust the menus depending on what is going on }
PROCEDURE AdjustMenus;
	VAR
		menu			: MenuRef;
		items			: INTEGER;
		index			: INTEGER;
	BEGIN
		
		menu:=GetMenu( mFile );
		items:=CountMItems( menu );
					
		FOR index:=1 TO items DO BEGIN
			EnableItem( menu , index );											
		END;
					
		menu:=GetMenu( mEdit );
		items:=CountMItems( menu );
		
		FOR index:=1 TO items DO BEGIN
			EnableItem( menu , index );											
		END;					
					
		IF ( gDoc = NIL ) THEN BEGIN
			menu:=GetMenu( mFile );
			DisableItem( menu , iClose );
			DisableItem( menu , iPrint );			
			
			menu:=GetMenu( mEdit );
			DisableItem( menu, iUndo );
			DisableItem( menu, iCut );
			DisableItem( menu, iCopy );
			DisableItem( menu, iPaste );
			DisableItem( menu, iClear );
			DisableItem( menu, iSelectAll );
			DisableItem( menu, iShowClip );
		END;
		
		IF ( gDoc <> NIL ) THEN BEGIN
			menu:= GetMenu( mFile );
			EnableItem( menu , iClose );
			EnableItem( menu , iPrint );

			menu:=GetMenu( mEdit );
			DisableItem( menu, iUndo );
			DisableItem( menu, iCut );
			DisableItem( menu, iCopy );
			DisableItem( menu, iPaste );
			DisableItem( menu, iClear );
			EnableItem( menu , iSelectAll );
			DisableItem( menu, iShowClip );						
		END;					
									
	END;



{ Check to see if a window belongs to the application - courtesy of CodeWarrior 9 Pascal
	TE_Sample }	
FUNCTION IsAppWindow( window: WindowRef ): BOOLEAN;

	BEGIN
		IF ( window = NIL ) THEN BEGIN
			IsAppWindow := FALSE;
		END
		ELSE BEGIN
			WITH WindowPeek( window )^ DO BEGIN
				IsAppWindow := ( windowKind = userKind );
			END;
		END;
	END;


FUNCTION WhichDocument( window : WindowRef ) : DocumentPeek;
	VAR
		myDoc			: DocumentPeek;
	BEGIN
		
		IF ( gDocument <> NIL ) THEN BEGIN
			myDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			myDoc:= gDocument;
			
			WHILE ( myDoc <> NIL ) DO BEGIN
				IF ( myDoc^.docWindow = window ) THEN BEGIN
					WhichDocument:= myDoc;
					myDoc:= NIL;
					DisposePtr( Ptr( myDoc ) );
					Exit( WhichDocument );
				END;			
				myDoc:= myDoc^.nextDoc;
			END;
			
			IF ( myDoc = NIL ) THEN BEGIN
				WhichDocument:=NIL;
				myDoc:= NIL;
				DisposePtr( Ptr( myDoc ) );
			END;
		END;
		
	END;

FUNCTION OpenPreferences:OSErr;
	VAR
		myVRefNum			: INTEGER;
		myDirID				: LONGINT;
		myFile				: FSSpec;
		fndrInfo			: FInfo;
	BEGIN
		gErr:=FindFolder($8000,'pref',false,myVRefNum,myDirID);	
		gErr:=FSMakeFSSpec(myVRefNum,myDirID,'My Type prefs',myFile);
		gErr:=FSpGetFInfo(myFile,fndrInfo);
		
		IF gErr <> noErr THEN
			BEGIN
			gErr:=FSpCreate(myFile,'huey','pref',0);
			FSpCreateResFile(myFile,'huey','pref',0);
			gPrefRefNum := FSpOpenResFile(myFile, fsRdWrPerm);
			END;
		
		
		UseResFile(gPrefRefNum);
		
		gSettings := PreferenceRef(Get1Resource('pref', 128));
		IF gSettings = NIL THEN
			BEGIN
				gSettings := PreferenceRef( NewHandle( sizeof( Preference ) ) );
{Init fields here}
	
				gSettings^^.what:=1;
				gSettings^^.custom:='';
				gSettings^^.how:=1;
	
				AddResource( Handle( gSettings ), 'pref', 128, 'Settings');
			END
		ELSE IF GetHandleSize( Handle( gSettings ) ) < SizeOf( Preference ) THEN
			SetHandleSize( Handle( gSettings ), SizeOf( Preference ) );

	UseResFile( gAppResFile );
	END;

PROCEDURE SaveSettings;
	BEGIN
		UseResFile( gPrefRefNum );
		ChangedResource( Handle( gSettings ) );
		UpdateResFile( gPrefRefNum );	
		UseResFile( gAppResFile );
	END;

PROCEDURE FrameList( myList : ListRef );
	BEGIN
		InsetRect( myList^^.rView , -1 , -1 );
		PMForeColor( ckWhite );
		PaintRect( myList^^.rView );
		PMForeColor( ckBlack );
		FrameRect( myList^^.rView );
		InsetRect( myList^^.rView , 1 , 1 );
	END;

PROCEDURE DefaultButton( theDialog : DialogRef; theItem	: INTEGER );
	VAR
		itemType			: INTEGER;
		itemHandle			: Handle;
		itemRect			: Rect;
	BEGIN
	
		PenSize( 3, 3 );
		GetDialogItem( theDialog, theItem, itemType, itemHandle, itemRect );
		InsetRect( itemRect, -4, -4 );
		FrameRoundRect( itemRect,18,18 );
		PenNormal;
		
	END;	


PROCEDURE DoAbout;
	CONST
		kAboutWind			= 128;
		kScreen				= 2;
		kTextID				= 128;
	VAR
		window				: DialogRef;
		event				: EventRecord;
		
		oldPort				: GrafPtr;
		
		theDelay			: LONGINT;
		
		theType				: INTEGER;
		theHandle			: Handle;
		theRect				: Rect;
		
		theText				: Handle;
		theTE				: TEHandle;
		theStyle			: StScrpHandle;
		theHeight			: INTEGER;
		index				: INTEGER;

PROCEDURE GetText ( dstRect : Rect; viewRect : Rect );
	BEGIN
		{ Get the styled text resource and put it into the rectangle }
			theTE:=TEStyleNew( dstRect , viewRect );
			theText:=GetResource('TEXT', kTextID );
			HLock(theText);
			
			HidePen;
				
			theStyle:= StScrpHandle((Get1Resource('styl', kTextID )));	
			TEStyleInsert( theText^, GetHandleSize(theText), theStyle, theTE);
			TESetAlignment(teFlushDefault, theTE);
				
			HUnlock( theText );
				
			ShowPen;
				
			theHeight:= TEGetHeight( theTE^^.nLines, 0 , theTE ); 
				
			TEUpdate( dstRect, theTE );
	END;
				
	BEGIN
	
		window:= GetNewDialog( kAboutWind , NIL , WindowRef( -1 ) );
	
		IF ( window <> NIL ) THEN BEGIN
			
			GetPort( oldPort );
			SetPort( window );
			SetFont( geneva, 9, [] );
			
			GetDialogItem( window , kScreen, theType, theHandle, theRect );
			DrawDialog( window );
			
			index:= 0;
			
			GetText( theRect, theRect );
			
			REPEAT
				IF index <= theHeight THEN
					BEGIN
						Delay( 5, theDelay );
						TEScroll( 0 , -1 , theTE );
						index:= index + 1;
					END
				ELSE
					BEGIN
						index:=0;
						GetText( theRect, theRect );
					END;
				
			UNTIL ( button );
			
			FlushEvents( mDownMask , 0 );
			TEDispose( theTE );
						
			DisposeDialog( window );
			DisposePtr( Ptr( window ) );

			SetPort( oldPort );
			oldPort:=NIL;
			DisposePtr( Ptr( oldPort ) );
						
		END;
	
	END;
	
{ Program code *********************************************************** }

{ A routine that copies string data into a ListHandle }
FUNCTION StringToList( theList : ListHandle; theString : Str255; rowNum : Integer; Alphabetical : Boolean ) : ListHandle;
	VAR
		aCell			: Cell;
	BEGIN		
		rowNum:=lAddRow( 1 , rowNum , theList );
		
		SetPt( aCell, 0 , rowNum );	 { Determine cell height and set the cell }
		LSetCell( @theString[1], Length(theString), aCell, theList );	{ copy the data }
		StringToList:=theList;
	END;

{ A procedure to install the font names into the list }
PROCEDURE InstallListData( theList : ListRef );
	VAR
		myFonts			: IntegerListRef;
		name			: Str255;
		rowNum			: INTEGER;
	BEGIN
	
		IF ( gFonts <> NIL ) THEN BEGIN
		
			myFonts:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
			myFonts:= gFonts^.next;
			
			rowNum:= 0;
			
			WHILE ( myFonts <> NIL ) DO BEGIN
				GetFontName( myFonts^.num , name );
				theList:= StringToList( theList , name , rowNum , FALSE { alphabetical } );
				rowNum:= ( rowNum + 1 );
				myFonts:= myFonts^.next;
			END;
		
		myFonts:= NIL;
		DisposePtr( Ptr( myFonts ) );
			
		END;
	
	END;

{ Create the list and fill it with the necessary data }
FUNCTION CreateDocList( theList : ListRef; theWindow : WindowRef; rView : Rect; theProc : INTEGER; grow,hScroll, vScroll, install : BOOLEAN ) : ListRef;
	VAR
		dataBounds		: ListBounds;
		aCell				: Cell;
	BEGIN
	
		SetRect( dataBounds, 0 , 0 , 1 , 0 );
		SetPt( aCell, 0 , 0 );
		
		theList:= LNew( rView , dataBounds , aCell , theProc , theWindow , TRUE ,{ AutoDraw}
			grow, hScroll, vScroll );
		
		LSetDrawingMode( FALSE, theList );
		IF ( install ) THEN InstallListData( theList );

		InvalRect( theList^^.rView );
		
		IF ( theList^^.vScroll <> NIL ) THEN
			InvalRect( theList^^.vScroll^^.contrlRect );
		IF ( theList^^.hScroll <> NIL ) THEN
			InvalRect( theList^^.hScroll^^.contrlRect );
		
		LSetDrawingMode( TRUE , theList );
		LUpdate( theList^^.port^.visRgn , theList );
		
		CreateDocList:= theList;
	END;

PROCEDURE AdjustWindOffsets;
	BEGIN
		
		IF ( gHOffset + kDefaultHOffset + ( gDoc^.docWindow^.portRect.right - gDoc^.docWindow^.portRect.left ) ) >
			qd.screenBits.bounds.right THEN BEGIN
				gHOffset:= kDefaultHOffset;
			END
			
			ELSE gHOffset:= gHOffset + kDefaultHOffset;
		
		IF ( gVOffset + kDefaultVOffset + ( gDoc^.docWindow^.portRect.bottom - gDoc^.docWindow^.portRect.top ) ) >
			qd.screenBits.bounds.bottom THEN BEGIN
				gVOffset:= ( 2 * kDefaultVOffset );	{ Compensate for the menu bar 	}
			END
			
			ELSE gVOffset:= gVOffset + kDefaultVOffset;
		
	END;

PROCEDURE DisposeDocument( index : INTEGER );
	VAR
		myDoc			: DocumentPeek;
		myPrev			: DocumentPeek;
		myStorage		: DocumentPeek;
	BEGIN
		
		IF ( gDocument <> NIL ) THEN BEGIN
			myDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			myPrev:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			myStorage:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			
			myDoc:= gDocument;
			myPrev:= gDocument;
			myStorage:= NIL;
			
			REPEAT
				myPrev:= myDoc;
				myDoc:= myDoc^.nextDoc;
			UNTIL ( myDoc^.docID = Index ) OR ( myDoc = NIL );
			
			IF ( myDoc <> NIL ) THEN BEGIN
				myStorage:= myDoc;
				myPrev^.nextDoc:= myDoc^.nextDoc;
				
				DisposeWindow( myStorage^.docWindow );
				DisposePtr( Ptr( myStorage^.docWindow ) );
				DisposeHandle( Handle( myStorage^.docList ) );
				
				IF ( gDocument^.nextDoc = myDoc ) THEN BEGIN
					
				END;
				
				myDoc:=NIL;
				
				myStorage^.nextDoc:= NIL;
				DisposePtr( Ptr( myStorage^.nextDoc ) );
				DisposePtr( Ptr( myStorage ) );
				DisposePtr( Ptr( myDoc ) );
			END;
						
			gDoc:= WhichDocument( FrontWindow );
			gDocID:= gDoc^.docID;
			
			
			myPrev:= NIL;
			DisposePtr( Ptr( myPrev ) );
			
			IF ( gDocument^.nextDoc = NIL ) THEN BEGIN
				gDocument:= NIL;
				DisposePtr( Ptr( gDocument ) );
				
				gDoc:=NIL;
				DisposePtr( Ptr( gDoc ) );
				gDocID:= 0;
				
			END;
		END;
		
	END;

PROCEDURE CreateDocument( index : INTEGER );
	BEGIN
				
		IF ( gDocument = NIL ) THEN BEGIN
			gDocument:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			gDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			gTemp:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
			
			WITH gDocument^ DO BEGIN
				docID:= 0;
				docWindow:= NIL;
				docList:= NIL;
				nextDoc:= NIL;
			END;			
			
			gDoc:= gDocument;
			
		END;
		
		gTemp:= gDoc;
		
		WHILE ( gTemp^.nextDoc <> NIL ) DO BEGIN
			gTemp:= gTemp^.nextDoc;
		END;
				
		gDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );

		WITH gDoc^ DO BEGIN
				docID:= Index;
				docWindow:= NIL;
				docList:= NIL;
				nextDoc:= NIL;
			END;
		
		gTemp^.nextDoc:= gDoc;	
			
	END;

PROCEDURE DoPrefs;
	CONST
		kPrefDialogID	= 129;
		kPrefStrings	= 128;
		
		kGeneralID		= 130;
		kPrintingID		= 131;
		
		kSave			= 1;
		kCancel			= 2;
		kGeneral		= 3;
		kPrinting		= 4;
		kMenu			= 5;
		
	VAR
		window			: DialogRef;
		oldPort			: GrafPtr;
		
		items			: INTEGER;
		itemHit			: INTEGER;
		
		itemType		: INTEGER;
		itemHandle		: Handle;
		itemRect		: Rect;
		
		Done			: BOOLEAN;
		myDITL			: Handle;
		
		current			: INTEGER;
		mValue			: INTEGER;

	PROCEDURE GetCustomString;
		CONST
			kCustomStringDialog		= 132;
		VAR
			myDialog			: DialogRef;
			oldPort				: GrafPtr;
			Done				: BOOLEAN;
			itemHit				: INTEGER;
			
			itemType			: INTEGER;
			itemHandle			: Handle;
			itemRect			: Rect;
			
		BEGIN
			
			GetPort( oldPort );
			myDialog:= GetNewDialog( kCustomStringDialog, NIL , WindowRef( -1 ) );
			SetPort( myDialog );
			
			Done:= FALSE;
			
			REPEAT
				ModalDialog( NIL, itemHit );
				
				CASE itemHit OF
					1: { Save }
						BEGIN
							GetDialogItem( myDialog, 3 , itemType, itemHandle, itemRect );
							GetDialogItemText( itemHandle , gSettings^^.custom );
							Done:=TRUE;
						END;
						
					2:	{ Cancel }
						BEGIN
							Done:= TRUE;
							gSettings^^.custom:='';
							gSettings^^.what:=3;
						END;
				END;
			UNTIL Done;
			
			DisposeDialog( myDialog );
			SetPort( oldPort );
		END;
		
	PROCEDURE ReflectSettings;
		BEGIN
			
			CASE current OF
				kGeneral:
					BEGIN						
						GetDialogItem( window, kMenu, itemType, itemHandle, itemRect );
						SetControlValue( ControlRef( itemHandle ) , gSettings^^.what );
					END;
				
				kPrinting:
					BEGIN
						GetDialogItem( window, kMenu, itemType, itemHandle, itemRect );
						SetControlValue( ControlRef( itemHandle ) , gSettings^^.how );
					END;
				
			END;
			
		END;
		
	BEGIN
		
		Done:=False;
		
		{ Get and set up the dialog }
			window:= GetNewDialog( kPrefDialogID , NIL , WindowRef( -1 ) );
			GetPort( oldPort );
			SetPort( window );
			SetPalette( window, gPalette, TRUE );
		
		items:=CountDITL( window );
		
		GetDialogItem( window, kGeneral, itemType, itemHandle, itemRect );
		SetControlValue( ControlRef( itemHandle ) , 1 );
		
		myDITL:=GetResource( 'DITL' , kGeneralID );
		AppendDITL( window , myDITL , overlayDITL );
		ReleaseResource( myDITL );
		
		current:= kGeneral;
				
		ReflectSettings;
				
		DefaultButton( window, kSave );
		
		REPEAT
			ModalDialog( NIL, itemHit );
			
			CASE itemHit OF
				kSave:
					BEGIN
						SaveSettings;
						Done:=True;
					END;
					
				kCancel:
					Done:=True;
					
				kGeneral, kPrinting:
					BEGIN
						GetDialogItem( window, itemHit, itemType, itemHandle, itemRect );
						SetControlValue( ControlRef( itemHandle ) , ABS( GetControlValue( ControlRef( itemHandle ) ) - 1 ) );
						
						CASE itemHit OF
							kGeneral:
								BEGIN
									GetDialogItem( window , kPrinting , itemType, itemHandle, itemRect );
									SetControlValue( ControlRef( itemHandle ) , 0 );
									ShortenDITL( window , ( CountDITL( window ) - items ) );
									
									myDITL:=GetResource( 'DITL' , kGeneralID );
									AppendDITL( window , myDITL , overlayDITL );
									ReleaseResource( myDITL );
									
									current:=kGeneral;	
								END;
								
							kPrinting:
								BEGIN
									GetDialogItem( window , kGeneral, itemType, itemHandle, itemRect );
									SetControlValue( ControlRef( itemHandle ) , 0 );
									ShortenDITL( window , ( CountDITL( window ) - items ) );

									myDITL:=GetResource( 'DITL' , kPrintingID );
									AppendDITL( window , myDITL , overlayDITL );
									ReleaseResource( myDITL );									
									
									current:= kPrinting;							
								END;
						END;
					END;
				
				kMenu:
					BEGIN
					
						GetDialogItem( window, kMenu, itemType, itemHandle, itemRect );
						mValue:= GetControlValue( ControlRef( itemHandle ) );	
					
						CASE current OF
							kGeneral:
								BEGIN
									gSettings^^.what:=mValue;
									
									IF mValue = 5 THEN BEGIN { If it is custom }
										GetCustomString;
									END;
								END;
								
							kPrinting:
								BEGIN
									gSettings^^.how:=mValue;
								END;
						END;
					
					END;
					
			END;
			
			ReflectSettings;
			
		UNTIL ( Done );

		DisposeDialog( window );
		SetPort( oldPort );
		
	END;	



PROCEDURE DoNew;
	VAR
		title				: Str255;
		boundsRect		: Rect;
	BEGIN
		
		gDocCount:= ( gDocCount + 1 );
		CreateDocument( gDocCount );
		
		{ Take the system color capabilities into account }
		
		SetRect( boundsRect, gHOffset, gVOffset , ( gHOffset + 180 ) , ( gVOffset + 270 ) );
		
		IF gOSInfo.HasColor THEN BEGIN
			gDoc^.docWindow:=NewCWindow( NIL, boundsRect , '' , TRUE { visible },
				documentProc, WindowRef( -1 ) , TRUE { goAway }, 0 { refCon } );
		END	
		ELSE BEGIN gDoc^.docWindow:=NewWindow( NIL, boundsRect , '' , TRUE { visible },
				documentProc, WindowRef( -1 ) , TRUE { goAway }, 0 { refCon } );
		END;
		
		AdjustWindOffsets;
		
		{ Set up the document structures }
		WITH gDoc^ DO BEGIN
			SetPort( docWindow );
			
			NumToString( gDocCount , title );
			title:= ( 'Untitled ' + title );
			SetWTitle( docWindow , title );
			
			SetWRefCon( docWindow , gDocCount );
			
			DrawGrowIcon( docWindow );
			SetFont( geneva , 9 , [] );
			SetRect( boundsRect , 0 , 0 , 165, 255 );
			docList:=CreateDocList( docList , docWindow, boundsRect , kDefaultListProc, TRUE { grow }, TRUE, TRUE, TRUE );
			
			ShowWindow( docWindow );
						
		END;
		
		gDocID:= gDoc^.docID;
				
	END;
	
{ Event handling code **************************************************** }

PROCEDURE Terminate;	
	BEGIN
		
		IF ( gDocument <> NIL ) THEN BEGIN
			{ Clean out all of the documents to free memory }
			
			gDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );	
			gDoc:= gDocument^.nextDoc;
			
			WHILE ( gDoc <> NIL ) DO BEGIN
				
				DisposeWindow( gDoc^.docWindow );
				DisposePtr( Ptr( gDoc^.docWindow ) );
				DisposeHandle( Handle( gDoc^.docList ) );
				
				gTemp:= gDoc;
				gDoc:= gDoc^.nextDoc;
				
			END;;
		
			DisposePtr( Ptr( gDocument ) );
			DisposePtr( Ptr( gDoc ) );
			DisposePtr( Ptr( gTemp ) );	
		
		END;
	
		gDone:=True;
	END;

PROCEDURE HandleAppleMenu( theItem : INTEGER );
	VAR
		itemStr		: Str255;
		refNum		: INTEGER;
	BEGIN		
		CASE theItem OF
			iAbout:
				BEGIN
					DoAbout;
				END;
				
		  OTHERWISE
		  	BEGIN
		  		GetMenuItemText( GetMenuHandle( mApple ), theItem, itemStr );
				refNum := OpenDeskAcc( itemStr );
			END;
		END;	
	END;

PROCEDURE HandleFileMenu( theItem : INTEGER );
	VAR
		goodChoice			: BOOLEAN;
	BEGIN
		CASE theItem OF
			iNew:
				DoNew;
			
			iClose:
				BEGIN
					IF ( gDoc^.docList <> NIL ) THEN LDispose( gDoc^.docList );
					DisposeDocument( GetWRefCon( gDoc^.docWindow ) );
				END;
			
			iPrefs:
				DoPrefs;
			
			iPageSetup:
				goodChoice:=PrStlDialog( gPrintRef );		
			
			iPrint:
				DoPrint;
													
			iQuit:
				Terminate;

		END;
	END;

PROCEDURE HandleEditMenu( theItem : INTEGER );
	VAR
		myCell			: Cell;
		rowNum			: INTEGER;
	BEGIN
		CASE theItem OF
			iSelectAll:
				BEGIN

					FOR rowNum:=0 TO gDoc^.docList^^.dataBounds.bottom DO BEGIN					
						SetPt( myCell,0,rowNum);				
						LSetSelect( TRUE, myCell, gDoc^.docList );
					END;
					
				END;
		END;
	END;

PROCEDURE HandleMenuChoice( choice : LONGINT );
	VAR
		theMenu, theItem		: INTEGER;
	BEGIN
		IF choice <> 0 THEN
			BEGIN
				theMenu:=HiWord( choice );
				theItem:=LoWord( choice );
				
				CASE theMenu OF
					mApple: HandleAppleMenu( theItem );
					mFile: HandleFileMenu( theItem );
					mEdit: HandleEditMenu( theItem );
				END;
				
				HiliteMenu(0);
			END;
	END;

PROCEDURE DoContentClick( event : EventRecord; window : WindowRef );
	VAR
		mouse			: Point;
		listClick		: BOOLEAN;

	BEGIN
		SetPort( window );
		
		mouse:= event.where;
		GlobalToLocal( mouse );
		
		IF ( gDoc^.docList <> NIL ) THEN BEGIN
			listClick:= LClick( mouse, event.modifiers, gDoc^.docList );
		END;
		
		
	END;

PROCEDURE HandleMouseDown( event : EventRecord );
	VAR
		window			: WindowRef;
		part				: INTEGER;
		choice			: LONGINT;
		gone				: BOOLEAN;
		
		myDoc			: DocumentPeek;
	BEGIN
		part:=FindWindow( event.where , window );

		
		CASE part OF
			inMenuBar:
				BEGIN
					choice:=MenuSelect( event.where );
					HandleMenuChoice( choice );
				END;
			
			inSysWindow:
				SystemClick( event , window );
				
			inDrag:
				BEGIN
					DragWindow( window, event.where, qd.screenBits.bounds );
					SelectWindow( window );
					gDoc:= WhichDocument( window );
					gDocID:= gDoc^.docID;
				END;
			
			inContent:
				BEGIN
					SelectWindow( window );
					gDoc:= WhichDocument( window );
					gDocID:= gDoc^.docID;
					DoContentClick( event , window );
				END;
				
			inGoAway:
				BEGIN
					gone:=TrackGoAway( window, event.where );
					IF ( gone ) THEN BEGIN
						
						myDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) ); 
						myDoc:= WhichDocument( window );
						
						IF ( myDoc^.docList <> NIL ) THEN LDispose( myDoc^.docList );
						DisposeDocument( GetWRefCon( window ) );
						DisposePtr( Ptr( window ) );					
					END;
				END;	
				
		END;
	END;

PROCEDURE DoUpdate( window : WindowRef );
	VAR
		myDoc			: DocumentPeek;
	BEGIN
		IF ( IsAppWindow( window ) ) THEN BEGIN
			BeginUpdate( window );
			
			IF ( gDocument <> NIL ) THEN BEGIN
				myDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
				myDoc:= WhichDocument( window );		
				
				{ removed call to DrawControls }
				
				IF ( myDoc <> NIL ) THEN BEGIN
					IF ( myDoc^.docList <> NIL ) THEN LUpdate( myDoc^.docList^^.port^.visRgn , myDoc^.docList );
					DrawGrowIcon( myDoc^.docWindow );					
				END;
				
				myDoc:= NIL;
				DisposePtr( Ptr( myDoc ) );
			END;		
			
			EndUpdate( window );
		END;
	END;

PROCEDURE DoActivate( window: WindowRef; becomingActive: BOOLEAN );
		VAR
			myDoc			: DocumentPeek;
		BEGIN
			
			IF IsAppWindow( window ) THEN BEGIN
			
				myDoc:= DocumentPeek( NewPtr( SizeOf( Document ) ) );
				myDoc:=WhichDocument( window );
			
				IF ( becomingActive ) THEN BEGIN
					IF ( myDoc^.docList <> NIL ) THEN LActivate( TRUE, myDoc^.docList );
				END
				
				ELSE IF ( myDoc^.docList <> NIL ) THEN LActivate( FALSE, myDoc^.docList );
			END;
		
		END;

PROCEDURE DoEvent( event : EventRecord );
	VAR
		aPoint			: Point;
		err				: OSErr;		
		theChar			: CHAR;
	BEGIN
		
		CASE event.what OF
			nullEvent:
				BEGIN
				END;
			
			mouseDown:
				BEGIN
					AdjustMenus;
					HandleMouseDown( event );						
				END;
				
			keyDown, autoKey:
				BEGIN
					theChar:=CHR( BitAnd( event.message,charCodeMask ) );
					IF ( BitAnd( event.modifiers, cmdKey ) <> 0 ) THEN BEGIN
						HandleMenuChoice( MenuKey( theChar ) );
					END
					
					ELSE BEGIN
					END;
				END;
				
			updateEvt:
				BEGIN
					DoUpdate( WindowRef( event.message ) );
				END;
				
			activateEvt:
				BEGIN
					DoActivate( WindowRef( event.message ) , BAnd( event.modifiers, activeFlag ) <> 0 );
				END;
				
			diskEvt:
				BEGIN
					IF ( HiWrd( event.message ) <> noErr ) THEN BEGIN
						SetPt( aPoint, kDILeft, kDITop );
						err := DIBadMount( aPoint, event.message );
					END;
				END;
		END;
		
	END;

PROCEDURE GetEvent;
	VAR
		event			: EventRecord;
		gotEvent			: BOOLEAN;
	BEGIN
		
		IF gOSInfo.HasWNE THEN BEGIN
			gotEvent:=WaitNextEvent( everyEvent, event, kSleep , NIL )
		END
		
		ELSE BEGIN
			SystemTask;
			gotEvent:=GetNextEvent( everyEvent,event );
		END;
		
		IF ( gotEvent ) THEN
			DoEvent( event )
		
		ELSE BEGIN
		END;
		
	END;

PROCEDURE MainLoop;
	BEGIN
		gDone:= FALSE;
		gDocID:= 0;
		gDocCount:= 0;
		
		gHOffset:= kDefaultHOffset;
		gVOffset:= ( 2 * kDefaultVOffset );	{ Compensate for the menu bar}
		
		gPrintRef:= THPrint( NewHandle( SizeOf( TPrint ) ) );
		
		PrOpen;
		PrintDefault( gPrintRef );
		
		gPalette:=GetNewPalette( 128 );
		
		gAppResFile:=CurResFile;
		
		gErr:=OpenPreferences;
				
		WHILE ( gDone = FALSE ) DO
			GetEvent;
			
		PrClose;
	END;	


{ Initalization code  **************************************************** }
	
{ Trap checking routines from IM courtesy of Apple Computer }

FUNCTION NumToolboxTraps : Integer;
	BEGIN
		IF NGetTrapAddress( _InitGraf, ToolTrap ) = NGetTrapAddress( $AA6E , ToolTrap ) THEN
			NumToolboxTraps:= $200
		ELSE
			NumToolboxTraps:= $400;
	END;
	
FUNCTION GetTrapType( theTrap : Integer ) : TrapType;
	CONST
		TrapMask	= $0800;
	BEGIN
		IF BAND( theTrap , TrapMask ) > 0 THEN
			GetTrapType:= ToolTrap
		ELSE
			GetTrapType:=OSTrap;
	END;
	
FUNCTION TrapAvailable( theTrap : Integer ) : Boolean;
	VAR
		tType	: TrapType;
	BEGIN
		tType:=GetTrapType( theTrap );
		IF tType = ToolTrap THEN
			BEGIN
				theTrap:=BAND( theTrap , $07FF );
				IF theTrap >= NumToolboxTraps THEN
					theTrap:=_Unimplemented;
			END;
		TrapAvailable:=NGetTrapAddress( theTrap , tType ) <>
			NGetTrapAddress( _Unimplemented , ToolTrap );
	END;
{ ----------------------------------------------------------- }	

{ Routines to check for various traps }	

FUNCTION GestaltAvailable : Boolean;
	CONST
		_Gestalt	= $A1AD;
	BEGIN
		GestaltAvailable:=TrapAvailable( _Gestalt );
	END;
	
FUNCTION WNEAvailable : Boolean;
	CONST
		_WaitNextEvent	= $A860;	{ trap number of WaitNextEvent }
	BEGIN
		WNEAvailable:=TrapAvailable( _WaitNextEvent );
	END;
{ ----------------------------------------------------------- }	


PROCEDURE InitMyOSInfo;
	VAR
		myBit		: Integer;
		myFeature	: LongInt;
		myErr		: Integer;
		
	BEGIN
		{ Basic trap calls }
			gOSInfo.HasGestalt:=GestaltAvailable;
			gOSInfo.HasWNE:=WNEAvailable;
		
		{ Gestalt attr calls }
			
		IF gOSInfo.HasGestalt THEN
			BEGIN

				{ Drag Manager }
					myErr:=Gestalt( gestaltDragMgrAttr , myFeature );
					IF myErr <> noErr THEN

					ELSE BEGIN
						myBit:=gestaltDragMgrPresent;
						IF BitTst( @myFeature , 31 - myBit ) = True THEN
							gOSInfo.HasDragMgr:=True
						ELSE
							gOSInfo.HasDragMgr:=False;
					END; 
					
					IF gOSInfo.HasDragMgr THEN
						BEGIN						
							myErr:=Gestalt( gestaltDragMgrAttr , myFeature );
							IF myErr <> noErr THEN

							ELSE BEGIN
								myBit:=gestaltDragMgrFloatingWind;
								IF BitTst( @myFeature , 31 - myBit ) = True THEN
									gOSInfo.HasDragFloat:=True
								ELSE
									gOSInfo.HasDragFloat:=False;
							END; 
						END;

					IF gOSInfo.HasDragMgr THEN
						BEGIN						
							myErr:=Gestalt( gestaltDragMgrAttr , myFeature );
							IF myErr <> noErr THEN

							ELSE BEGIN
								myBit:=gestaltPPCDragLibPresent;
								IF BitTst( @myFeature , 31 - myBit ) = True THEN
									gOSInfo.HasDragPPC:=True
								ELSE
									gOSInfo.HasDragPPC:=False;
							END; 
						END;
				{ end Drag Manager end ------------------------------------------ }
				
				{ AE Manager }
					myErr:=Gestalt( gestaltAppleEventsAttr , myFeature );
					IF myErr <> noErr THEN

					ELSE BEGIN
						myBit:=gestaltAppleEventsPresent;
						IF BitTst( @myFeature , 31 - myBit ) = True THEN
							gOSInfo.HasAEMgr:=True
						ELSE
							gOSInfo.HasAEMgr:=False;
					END;
				{ end AE Manager end -------------------------------------------- }
				
				{ Help Manager }
					myErr:=Gestalt( gestaltHelpMgrAttr , myFeature );
					IF myErr <> noErr THEN

					ELSE BEGIN
						myBit:=gestaltHelpMgrPresent;
						IF BitTst( @myFeature , 31 - myBit ) = True THEN
							gOSInfo.HasHelpMgr:=True
						ELSE
							gOSInfo.HasHelpMgr:=False;
					END;
				{ end Help Manager end ------------------------------------------ }
				
				{ Pop-Up CDEFs are present }
					myErr:=Gestalt( gestaltPopupAttr , myFeature );
					IF myErr <> noErr THEN

					ELSE BEGIN
						myBit:=gestaltPopupPresent;
						IF BitTst( @myFeature , 31 - myBit ) = True THEN
							gOSInfo.HasPopUps:=True
						ELSE
							gOSInfo.HasPopUps:=False;
					END;
				{ end Pop-UP CDEFs are present end ------------------------------ }							
				
				{ Has Color Quickdraw }
					myErr:=Gestalt( gestaltQuickdrawFeatures , myFeature );
					IF myErr <> noErr THEN

					ELSE BEGIN
						myBit:=gestaltHasColor;
						IF BitTst( @myFeature , 31 - myBit ) = True THEN
							gOSInfo.HasColor:=True
						ELSE
							gOSInfo.HasColor:=False;
					END;
				{ end Has Color Quickdraw end ----------------------------------- }	
				
				{ Has the Thread Manager }
					myErr:=Gestalt( gestaltThreadMgrAttr , myFeature );
					IF  myErr <> noErr THEN
					
					ELSE BEGIN
						myBit:=gestaltThreadMgrPresent;
						IF BitTst( @myFeature , 31 - myBit ) = TRUE THEN
							gOSInfo.HasThreads:= TRUE
						ELSE
							gOSInfo.HasThreads:= FALSE;
					END;	
				{ end Has the Thread Manager }		
			END;
					
	END;

PROCEDURE InstallFonts( myMenu : MenuHandle );
	VAR
		index		: INTEGER;
		name			: Str255;
		
		cur			: IntegerListRef;
		prev			: IntegerListRef;
		head			: IntegerListRef;
		
	BEGIN
	
		gFonts:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
		gFonts:=NIL;
		gFonts^.next:=NIL;
	
		cur:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
		prev:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
		head:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
		
		head^.next:= NIL;
		cur:= head;
		prev:= head;
	
		FOR index:= 1 TO CountMItems( myMenu ) DO BEGIN
			GetMenuItemText( myMenu , index , name );
			
			prev:=cur;
			cur:= IntegerListRef( NewPtr( SizeOf( IntegerList ) ) );
			cur^.next:=NIL;
			prev^.next:= cur;
			GetFNum( name , cur^.num );
			
		END;
	
		gFonts:= head;
	
		cur:= NIL;
		prev:= NIL;
		head:= NIL;
		
		DisposePtr( Ptr( cur ) );
		DisposePtr( Ptr( prev ) );
		DisposePtr( Ptr( head ) );		
	END;


PROCEDURE Initalize;
	VAR
		myMenuBar		: Handle;
		myMenu			: MenuHandle;
	BEGIN
		InitGraf(@qd.thePort);
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(NIL);
		InitCursor;
		InitPalettes;
		MoreMasters;
		
		myMenuBar:=GetNewMBar( kMenuBar );	{ Get the MBAR resource with ID of 128 }
		SetMenuBar( myMenuBar ); { Set this resource to be the menu bar }
		DisposeHandle( myMenuBar );
		
		myMenu:=GetMenu( mApple );	{ Get the apple menu and fill it }
		AppendResMenu( myMenu,'DRVR' );
		
		myMenu:=GetMenu( mDummy );	{ Get this temp menu and fill it }
		AppendResMenu( myMenu , 'FONT' );
		
		InstallFonts( myMenu );
		
		myMenu:=NIL;
		DeleteMenu( mDummy );
		DisposeMenu( myMenu );
		
		DrawMenuBar;
		InitMyOSInfo;
	END;
	

BEGIN

	Initalize;
	
	MainLoop;

END.