{ /-------------------------------------------------------------------------------------- }
{ 	SWFPSReport.c }
{  }
{ 	Requires ALRT and DITL resource ID 200 to be copied from SpriteTest and put in  }
{ 	your project. Remember to include the SWFPSReport.h file as well. It will  }
{ 	call SysBeep if for some reason it can't display the alert. }
{  }
{ 	Make sure to set the Sprite's move time and the MaxFPS rate to 0; otherwise  }
{ 	the fps report will be innaccurate. (It still isn't terribly accurate, but should }
{ 	give you a pretty good idea of how fast the animation is going.) }
{ /-------------------------------------------------------------------------------------- }

unit SWFPSReport;

interface

	const
		kNoteAlertID = 200;

	var
		frames: longint;
		ticks: longint;

	procedure StartTimer;
	procedure ShowResults (frames: longint);

implementation
{ /-------------------------------------------------------------------------------------- }
{ 	Call StartTimer right before you start the animation }
{ /-------------------------------------------------------------------------------------- }

{$IFC undefined THINK_Pascal}
	uses
		Types, Events, Quickdraw, OSUtils, Dialogs, TextUtils;
{$ENDC}

	procedure StartTimer;
	begin
		ticks := TickCount;
	end;


{ /-------------------------------------------------------------------------------------- }
{ 	Call ShowResults as soon as your animation is done and pass to it the number of }
{ 	frames that have occured in the animation. }
{ /-------------------------------------------------------------------------------------- }

	procedure ShowResults (frames: longint);
		var
			framesString, secondsString, fpsString: Str255;
			seconds, fps, dummy: longint;
	begin
		seconds := round((TickCount - ticks) / 60.15);

		NumToString(frames, framesString);
		NumToString(seconds, secondsString);

		if seconds > 0 then
			dummy := frames div seconds
		else
			dummy := frames;

		fps := dummy;
		NumToString(fps, fpsString);

		ParamText(framesString, secondsString, fpsString, '');

		ShowCursor;

		if (NoteAlert(kNoteAlertID, nil) = -1) then
			SysBeep(10);
	end;

end.