unit MyFSAsyncs;

interface

	uses
		Types, Files;

	procedure FSHOpenAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSReadAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSWriteAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSCloseAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSDeleteAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSCatMoveAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSRenameAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
	procedure FSExchangeFilesAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);

implementation

	uses
		Devices,
		PreserveA5, MyLowLevel;

	procedure FSHOpenAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBHOpenAsync( HParmBlkPtr(pbp) );
	end;

	procedure FSReadAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBReadAsync(pbp);
	end;

	procedure FSWriteAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBWriteAsync(pbp);
	end;

	procedure FSCloseAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBCloseAsync(pbp);
	end;

	procedure FSRenameAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBHRenameAsync(HParmBlkPtr(pbp));
	end;

	procedure FSDeleteAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBHDeleteAsync(HParmBlkPtr(pbp));
	end;

	procedure FSCatMoveAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBCatMoveAsync(CMovePBPtr(pbp));
	end;

	procedure FSExchangeFilesAsync (pbp: univ ParmBlkPtr; comp: ProcPtr);
		var
			junk: OSErr;
			prp: XParmBlkPtr;
	begin
		prp := XParmBlkPtr(ord(pbp) - XParamBlockRecExtra);
		prp^.completion := comp;
		pbp^.ioCompletion := gPreCompletionProc;
		junk := PBExchangeFilesAsync(HParmBlkPtr(pbp));
	end;

end.