unit MyRegions;

interface

	uses
		Types, QuickDraw;
		
	procedure LocalToGlobalRegion( rgn: RgnHandle );
	procedure GlobalToLocalRegion( rgn: RgnHandle );
	procedure OutlineRegion( rgn: RgnHandle );
	procedure MakeRegionEmpty (rgn: RgnHandle);
	procedure UnionRgnRect( rgn: RgnHandle; const r: Rect );

implementation

	procedure MakeRegionEmpty (rgn: RgnHandle);
		var
			r: Rect;
	begin
		SetRect(r, 0, 0, 0, 0);
		RectRgn(rgn, r);
	end;

	procedure LocalToGlobalRegion( rgn: RgnHandle );
		var
			where: Point;
	begin
		where := Point(0);
		LocalToGlobal( where );
		OffsetRgn( rgn, where.h, where.v );
	end;

	procedure GlobalToLocalRegion( rgn: RgnHandle );
		var
			where: Point;
	begin
		where := Point(0);
		GlobalToLocal( where );
		OffsetRgn( rgn, where.h, where.v );
	end;

	procedure OutlineRegion( rgn: RgnHandle );
		var
			temprgn: RgnHandle;
	begin
		temprgn := NewRgn;
		CopyRgn( rgn, temprgn );
		InsetRgn( temprgn, 1, 1 );
		DiffRgn( rgn, temprgn, rgn );
		DisposeRgn( temprgn );
	end;

	procedure UnionRgnRect( rgn: RgnHandle; const r: Rect );
		var
			tmp: RgnHandle;
	begin
		tmp := NewRgn;
		RectRgn( tmp, r );
		UnionRgn( rgn, tmp, rgn );
		DisposeRgn( tmp );
	end;
	
end.
