///--------------------------------------------------------------------------------------
//	NSSpriteWorld8BitBlitters.h
//
//	Description: This is the include file for all the NSSpriteWorld8BitBlitters source files.
//
//	This file is based on the SpriteWorld blitters
///--------------------------------------------------------------------------------------


#ifndef __NSSPRITEWORLD8BITBLITTER__
#define __NSSPRITEWORLD8BITBLITTER__

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


///--------------------------------------------------------------------------------------
//		type definitions & conditional macros
///--------------------------------------------------------------------------------------

typedef unsigned long PixelChunk, *PixelChunkPtr, **PixelChunkHdl;

#define BytesToChunks(b) ((b) >> 2)
#define ChunksToBytes(b) ((b) << 2)

typedef unsigned long* PixelPtr;

///--------------------------------------------------------------------------------------
//	Function prototypes for all-bit blitters
///--------------------------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

void BlitPixie8Bit(
	register PixelChunkPtr srcPixelP,
	register PixelChunkPtr dstPixelP,
	register unsigned long rowsToCopy,
	register unsigned long numBytesPerRow,
	register unsigned long srcRowStride,
	register unsigned long dstRowStride);

void BlitPixieMask8Bit(
	register PixelPtr srcPixelP,
	register PixelPtr dstPixelP,
	register PixelPtr maskPixelP,
	register unsigned long rowsToCopy,
	register unsigned long numBytesPerRow,
	register unsigned long srcRowStride,
	register unsigned long dstRowStride);

void BlitPixiePartialMask8Bit(
	register PixelPtr srcPixelP,
	register PixelPtr dstPixelP,
	register PixelPtr maskPixelP,
	register unsigned long rowsToCopy,
	register unsigned long numBytesPerRow,
	register unsigned long srcRowStride,
	register unsigned long dstRowStride);


#ifdef __cplusplus
}
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#endif // __NSSPRITEWORLD8BITBLITTER__